Firebird ADO.NET Data provider for .NET and Mono 
================================================


------------------ 1.7.1 Release Candidate 1 ----------------------


2005-08-27 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird\FbCommand.cs:
	* FirebirdSql.Data.Gds\GdsStatement.cs:
	* FirebirdSql.Data.Embedded\FesStatement.cs:

		- Added support to INSERT INTO .... RETURNING statement of Firebird 2.0

2005-08-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird\FbCommand.cs:

		- Backported the new named parameters method from the v2.0

2005-08-12 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird\DbSchema\FbColumns.cs:
	* FirebirdSql.Data.Firebird\DbSchema\FbDomains.cs:
	* FirebirdSql.Data.Firebird\DbSchema\FbProcedureParameters.cs:
	* FirebirdSql.Data.Firebird\DbSchema\FbViewColumnUsage.cs:

		- Renamed column CHARACTER_LENGTH to "CHARACTER_LENGTH" to allow the query to run in Firebird 2.0		

2005-08-10 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.FirebirdClient.FbCommand.cs:

		- Initial fix for bug #1242812

2005-07-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Changes on implicit transaction handling, they will be discarded by doing 
		Commit when the command is a SELECT statement.

2005-07-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Changed the way to describe input parameters, not finished needs tetsing.

2005-07-20 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Changed the way to describe input parameters, not finished and needs tetsing.

2005-07-17 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbRemoteEvent.cs:

		- Check connection state on constructor ( Thanks to Michele Lepri )

2005-06-27 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbIndexes.cs:

		- Added ProcessResult implementation (Thanks to Rolo Tomasi)

	* FirebirdSql.Data.Firebird/DbSchema/FbUniqueKeys.cs:

		- Fixed parameter value in constructor (Thanks to Rolo Tomasi)

2005-06-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbColumns.cs:

		- Fixed default value retrieval. (Thanks to RoloTomasi.)

2005-06-13 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep4.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep7.cs:

		- Allow configuration of quoted identifiers usage. (Thanks to Ernesto Cullen for his help.)

	* FirebirdSql.WizardFramework/WizardForm.cs:

		- Allow to cancel wizard execution using ESC key.

	* FirebirdSql.Data.Firebird/Isql/FbBatchExecution.cs:

		- Updated documentation comments.

		- Added execution of SET GENERATOR commands.

2005-06-11 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep7.cs:

		- Add parameter information for DML statements.

2005-06-07 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/XdrStream.cs:

		- Fixed bug on numeric and decimal reads and writes.

	* FirebirdSql.Data.Gds/GdsArray.cs:
	* FirebirdSql.Data.Embedded/FesArray.cs:

		- Fixed bug on numeric and decimal array encoding.

2005-06-05 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsDatabase.cs:

		- Fixed problem with mono on linux when reading port number for firebird events
		connection (Gabriel Reid)


------------------ 1.7 Final Release ----------------------

2005-05-28 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDataSetGenerator.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/VSExtensibility.cs

		- Bug fixes for the DataSet generation and Visual Studio integration.

	* Update assembly version.

	* FirebirdSql.Data.Firebird/FbDataAdapter.cs:

		- Change to ensure the command has a valid connection before perform an update.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDesigner.cs

		- Force command initialization on .NET 1.0 and .NET 1.1

2005-05-25 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsConnection.cs:

		- Correctly disable Nagle Algorithm.

2005-05-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Services/FbBackupFile.cs:

		- Changed to be class instead of an struct, to allow it be used in C++

2005-05-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDatabaseInfo.cs:
	* FirebirdSql.Data.Common/IscHelper.cs:

		- Implemented new property ActiveUSers (Tracker item #1198051)

2005-05-18 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Isql/FbBatchExecution.cs:

		- Fixed constructor bug. (Thanks to Julien Ferraro)

2005-05-04 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- HasRows property will return true only for Select commands.

2005-04-30 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Close DataReader when preparing a new command.

2005-04-29 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Common/TypeHelper.cs:
	* FirebirdSql.Data.Firebird/Common/DbField.cs:
	* FirebirdSql.Data.Firebird/Gds/XdrStream.cs:

		- Fixed Decimal and Numeric field handling.

2005-04-27 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbException.cs:
	* FirebirdSql.Data.Common/BinaryEncoding.cs:
	
		- Fixed .NET Compact Framework Beta 2 build problems.

2005-04-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Isql/FbScript.cs:

		- Better handling of comments and strings.

	* FirebirdSql.Data.Firebird/Isql/FbBatchExecution.cs:

		- Fix bug on transaction handling.

2005-04-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/Charset.cs:

		- Try to make the SupportedCharsets property thread safe.

2005-04-14 Carlos Guzman Alvarez  <carlosga@telefonica.net>


	* FirebirdSql.Data.Firebird/Isql/FbBatchExecution.cs:

		- Added a new constructor.

	* FirebirdSql.Data.Firebird/Isql/FbScript.cs:

		- Try to avoid problem with / inside comments (needs tetsting)


------------------ Release Candidate 3 ----------------------


2005-04-11 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Make usage of the isc_dpb_overwrite parameter in CreateDatabase method.

2005-04-9 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Embedded/FesStatement.cs:

		- Try to fix performance problems when reading array fields using the embedded server.

2005-04-7 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/DbValue.cs:

		- Fixed bug in GetString method when reading 
		Clob values several times (Thanks to Mike Scott for his feedback).

2005-04-6 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Fixed output parameter handling.

2005-04-3 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Try to avoid breaking change on sp calls using ExecuteScalar method.

2005-03-31 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Isql/FbScript.cs:

		- Close the isql file after have readed the contents (Thanks to for Muthu Annamalai his feedback).

2005-03-31 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDataSetGenerator.cs:

		- Changed the way the DataSet is added to the designer (and serialized into source code)

2005-03-27 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Allow access to the RecordsAffected property when the reader is not closed (Thanks to Andrea Sansottera for his feedback)

	* FirebirdSql.Data.Firebird/FbDataAdapter.cs:

		- Changes to improve the RowUpdated event handling, they
		needs testing (Thanks to Andrea Sansottera for his feedback)

2005-03-26 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDataAdapter.cs:

		- Improved error reporting on Updates (Thanks to Andrea Sansottera for his feedback)

2005-03-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Fixed problem with implicit transaction Commit's and Rollback's
		when the objects are collected by the GC.

2005-03-15 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Changed all references to CurrentUICulture to CurrentCulture.

2005-03-11 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Isql/FbBatchExecution.cs:

		- Added CREATE DESCENDING INDEX command handling. (Thanks to Daniel Letecky)

	* FirebirdSql.Data.Firebird/Isql/FbScript.cs:

		- Try to improve handling of -- comments (changes doesn't cover all cases of quoted ' usage)

	* FirebirdSql.Data.Gds/GdsStatement.cs

		- Changed encoding of relation, field, alias and owner names, to use
		the connection character set.

2005-03-07 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Isql/FbScript.cs:

		- Fixed comment removal (Thanks to Daniel Letecky)

2005-02-28 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionStringBuilder.cs:

		- Fixed problem with space handling. Added NUnit test case.

------------------ Release Candidate 2 ----------------------

2005-02-21 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/IscException.cs

		- Changes for better exception handling on message formatting.

2005-02-16 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Added missing synonym (Thanks to Mike Scott by his feedback)

	* FirebirdSql.Data.Firebird/DbSchema/FbProcedures.cs:

		- Added column for the procedure source.

2005-02-15 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsStatement.cs:
	* FirebirdSql.Data.Gds/FesStatement.cs:

		- Fixed problem with transaction value set (Thanks to Oleg Paschenko)

2005-02-14 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/VSExtensibility.cs:

		- Added Visual Studio 2002 support.

2005-02-14 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsConnection.cs:

		- Do not include calls to Socket.SetSocketOption when working
		with the .NET Compact Framework that should allow the provider
		to do connections when working with the .NET Compact Framework
		(Thanks to Fonzetto Michaël for his feedback)

2005-02-13 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsConnection.cs:

		- Changed ProtocolType used to configure the Socket to ProtocolType.Tcp

	* FirebirdSql.Data.Firebird/Isql/FbScript.cs:

		- Undo latest changes on RemoveComments method as they breaks the execution of some tstatements.

	* FirebirdSql.Data.Firebird/Isql/FbBatchExecition.cs:

		- Fixed bug on autocommit mode.

2005-02-12 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/IscException.cs:

		- Fix for exception message building.


------------------ Release Candidate 1 ----------------------

2005-02-04 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Fixed SP execution on ExecuteScalar method (Thanks to Alessandro Petrelli for his feddback)

	* FirebirdSql.Data.Firebird/FbParameter.cs:
	* FirebirdSql.Data.Common./DbField.cs:

		- Fixed null Guid handling.

2005-01-30 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Embedded/FesArray.cs:

		- Fixed problem with 0 lowerbound arrays.

2005-01-30 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Fixed sqal generation for strored procedure names (Thanks to Andrzej Kaczmarczyk for his feedback).

2005-01-28 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/DbField.cs:

		- Fixed incorrect mapping (Thanks to Frans Bouma for his feedback.)

2005-01-27 Carlos Guzman Alvarez  <carlosga@telefonica.net>
	
    	- Reformatted the source code.

	* FirebirdSql.Data.Gds/XdrStream.cs:

		- Fixed problem with system field values, now checks are done using the
		field character set (Thanks to Phaidros for his feedback).

    	* FirebirdSql.Data.Common/ITransaction.cs:
    	* FirebirdSql.Data.Embedded/FesTransaction.cs:	
    	* FirebirdSql.Data.Gds/GdsTransaction.cs:	
	
        	- Commented Prepare method overloads.

    	* FirebirdSql.Data.Embedded/FesTransaction.cs:	

        	- Commented PInvoke funcition definitions that aren't used.

2005-01-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsDatabase.cs:

		- Fixed problem on Event manager close.

2005-01-21 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep1.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep2.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep3.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep4.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep5.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep6.cs

		- Minor changes on label's text.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep7.cs

		- Changes to show information abot the errors got on data adapter configuration.

	* Updated license headers.

	* FirebirdSql.Data.Common/StatementBase.cs:

		- Fix ClearArrayHandles method by checking for array fields.

2005-01-19 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/StatementBase.cs:
	* FirebirdSql.Data.Embedded/FesStatement.cs:
	* FirebirdSql.Data.Gds/GdsStatement.cs:

		- Try to fix performance problems with array fields on select statements.

2005-01-18 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Isql/FbScript.cs:

		- Changes for better handling of comment removal (Andreas Sandner)

2005-01-14 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Embedded/FesArray.cs:
	* FirebirdSql.Data.Embedded/FesBlob.cs:
	* FirebirdSql.Data.Embedded/FesConnection.cs:
	* FirebirdSql.Data.Embedded/FesDatabase.cs:
	* FirebirdSql.Data.Embedded/FesServiceManager.cs:
	* FirebirdSql.Data.Embedded/FesStatement.cs:
	* FirebirdSql.Data.Embedded/FesTransaction.cs:
	* FirebirdSql.Data.Gds/GdsArray.cs:
	* FirebirdSql.Data.Gds/GdsBlob.cs:
	* FirebirdSql.Data.Gds/GdsDatabase.cs:
	* FirebirdSql.Data.Gds/GdsEventManager.cs:
	* FirebirdSql.Data.Gds/GdsServiceManager.cs:
	* FirebirdSql.Data.Gds/GdsStatement.cs:
	* FirebirdSql.Data.Gds/GdsTransaction.cs:

		- Cleanup.

2005-01-02 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.WizardFramework/WizardStep.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep1.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep2.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep3.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep4.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep5.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep6.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep7.cs
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDataSetGenerator.cs

		- Changes for try to get the Wizard working on VS 2003.

	* FirebirdSql.Data.Common/BinaryEncoding.cs

		- Integrate the Encoding implementation for the OCTETS character set
		Contributed by Jim Beveridge. (It's under the Public Domain)

	* FirebirdSql.Data.Common/Charset.cs:

		- Integrate the BinaryEncoding implementation.

	* FirebirdSql.Data.Embedded/XsqldaMarshaler.cs:

		- Added support for Guid parameters.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDesigner.cs

		- Show a MessageBox with the exception deatils.

-------------------------- Beta 3 ----------------------------

2005-01-01 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		-Fixed problem with the Guid parameters support.

	* FirebirdSql.Data.Firebird/Isql/FbbatchExecution.cs:

		- Added initial autocommit mode support (needs testing).

2004-12-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/Charset.cs:
	* FirebirdSql.Data.Common/DbDataType.cs:
	* FirebirdSql.Data.Common/DbField.cs:
	* FirebirdSql.Data.Common/DbValue.cs:
	* FirebirdSql.Data.Common/TypeHelper.cs:
	* FirebirdSql.Data.Gds/XdrStream.cs:
	* FirebirdSql.Data.Firebird/FbCharset.cs:
	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbDataReader.cs:
	* FirebirdSql.Data.Firebird/FbDbType.cs:
	* FirebirdSql.Data.Firebird/FbParameter.cs:

		- Added initial suport for the GUID datatype.
		Guids will be mapped to CHAR(16) CHARACTER SET OCTETS fields in firebird.
		In the FbParameter class Guid values should be passed as Guid instances or 
		byte arrays.
		The changes are not finished yet.
		A new Test suite for the Guid support is included.

		Thanks to Jim Beveridge for his help and feedback.

2004-12-21 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/DbValue.cs:

		- Fixed bug on long values conversion to string (Thanks to Sven Kammradt for his feedback).
		Test case added to the test suite.

2004-12-16 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommandbBuilder.cs:

		- Removed check of the DataColumn.Autoincrement property in the IsUpdateable method.

	* FirebirdSql.Data.Firebird/FbConnectionStringBuilder.cs:
	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Fixed globalization issues.

2004-12-13 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/FbDataAdapter/Designer/FbDataAdapterWizardSettings.cs
	* FirebirdSql.Data.Firebird/Design/FbDataAdapter/Designer/FbDataAdapterWizard.cs
	* FirebirdSql.Data.Firebird/Design/FbDataAdapter/Designer/FbDataAdapterDesigner.cs

		- Changes for see if we can get the wizard to work with VS 2003

2004-12-10 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Fixed validation of connection strings without a data source when the
		ServerType parameter is 1 (Thanks to Peter Turcan for his feedback).

	* FirebirdSql.Data.Common/Charset.cs:
	* FirebirdSql.Data.Common/CharsetCollection.cs:

		- Load encodings at runtime in order to improve memory usage. (Thnaks to Jim Beveridge for his feedback)

2004-12-08 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep2.cs

		- Fixed FillConnections method.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDataSetGenerator.cs

		- Prevent to generate Typed DataSets if the provider was
		not build with the VISUAL_STUDIO define

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/VSExtensibility.cs:

		- Fixed DTE creation when there are more than one Visual Studio instance.
		Reference:
			http://devresource.hp.com/technical_white_papers/CodeModel1.pdf

	* FirebirdSql.Data.Common/StatementBase.cs:

		- Better checks on Release method (Thanks to Pierre Arnaud)

-------------------------- Beta 2 ----------------------------

2004-12-03 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterWizardSettings.cs:

		- Fixed conversion doing a cast.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterWizardStep2.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterWizardStep4.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterWizardStep6.cs:

		- Changes for allow a better initialization of the step data when 
		the DataAdapter was already configured before.

	* Fixed FxCop issues.

	* FirebirdSql.Data.Gds/XdrStream.cs:

		- Fix Stream and IDisposable implementation.

2004-12-02 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Changes on the Firebird Events implementation.

	* FirebirdSql.Data.Firebird/FbDataReader.cs:
	* FirebirdSql.Data.Common/DbValue.cs:
		
		- Try to get the FbDataReader.GetBoolean method working.

2004-12-01 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbTransaction.cs:

		- Added a new Commit(string) method (Thanks to for Andrzej Kaczmarczyk his feedback)

2004-11-29 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Reorganization of the Services sources.

2004-11-28 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/IscException.cs:

		- Fix for the latest changes of the exception message formatting

2004-11-26 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/IscException.cs:

		- If the resource cannot be found raise the 
		exception with the default message.

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Changes on Transaction and resources management.

	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Fixed problem with the CreateDatabase problem, when it's requested to not
		overwrite the an existing database database, and there are no real database 
		to connect to.

2004-11-25 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSQl.Data.Gds/GdsTransaction.cs:
	* FirebirdSQl.Data.Embedded/FesTransaction.cs:

		- Fixed bug in the Dispose method (Thanks to Pierre Arnaud for his feedback)
		  Test case added for this bug.

2004-11-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/DataSetGenerator.cs:

		- Set the dataset namespace.

2004-11-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/DataSetGenerator.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/VSExtensibility.cs:

		- Changes for better support of Visual Studio project files,
		when adding Typed Datasets (not finished.)

2004-11-21 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbErrorCollection.cs:
	* FirebirdSql.Data.Firebird/FbParameterCollection.cs:
		
			- Better fit to ADO.NET
	
	* FirebirdSql.Data.Common/IscErrorCollection.cs:
	* FirebirdSql.WizardFramework/WizardStepCollection.cs:
	* FirebirdSql.Data.Firebird/FbConnectionString.cs:
	* FirebirdSql.Data.Firebird/FbRemoteEventEventArgs.cs:
	* FirebirdSql.Data.Firebird/Isql/FbbatchExecution.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/DataSetGenerator.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep6.cs:
	
			- Fixed FxCop issues.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/VSExtensibility.cs:
	
			- Minor reorganization.
			
2004-11-20 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/XdrStream.cs:

		- Changes to try to handle correctly the character sets (Thanks to Kazuhiro Kato for his feedback)

	* FirebirdSql.Data.Common/Charset.cs:
	* FirebirdSql.Data.Common/BlobBase.cs:
	* FirebirdSql.Data.Common/DbField.cs:
	* FirebirdSql.Data.Common/RemoteEvent.cs:
	* FirebirdSql.Data.Common/StatementBase.cs:
	* FirebirdSql.Data.Embedded/FesArray.cs:
	* FirebirdSql.Data.Embedded/FesStatement.cs:
	* FirebirdSql.Data.Embedded/XsldaMarshaler.cs:
	* FirebirdSql.Data.Gds/GdsArray.cs:
	* FirebirdSql.Data.Gds/XdrStream.cs:

		- Make the charset class to be a full wrapper for the .NET encoding class.

2004-11-19 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.WizardFramework/WizardStep.cs:
	* FirebirdSql.Data.WizardFramework/WizardForm.cs:

		- Added changes to allow condition navigation to previous steps.

		- Simplify finish navigation.

	* FirebirdSql.Data.WizardFramework/WizardForm.cs:

		- Moved Validation handler configuration to the ShowStep method.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/FbDataAdadapterWizardStep7.cs:

		- New wizard step to show the results.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/FbDataAdadapterWizardForm.cs:

		- Removed DataAdapter configuration code.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/DataSetGenerator.cs:

		- Let Visual Studio to generate the source code for the Typed DataSet.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/VSExtensibility.cs:

		- Changes to add a file as an embedded resource.

2004-11-16 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionInternal.cs:

		- Fixed bug in DropDatabase implementation. (Thanks to Daniel Letecky for his feedback.)

	* FirebirdSql.Data.Common/CharsetCollection.cs:
	* FirebirdSql.Data.Common/IscErrorCollection.cs:

		- Changes to inherit from CollectionBase

2004-11-13 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDesigner.cs:

		- Override OnSetComponentDefaults and launch the wizard for initialization.

		- Do not use localization support in the wizard for now.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/DataSetGenerator.cs:

		- Use FillSchema to generate the tables in the DataSet.

		- Make one of the DataSet generation methods to be more
		general (it takes a connection string instead of a DataAdapter
		as parameter).

2004-11-12 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbTransaction.cs:

		- Try to fix a problem with the transactions and data readers handling.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/VSextensibility.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/DataSetGenerator.cs:

		- Added class for handle Visual Studio Extensibility support
		(No terminado)

2004-11-11 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/DataSetGenerator.cs:

		- New DataSet generation class for the Design Time support.

2004-11-10 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbRemoteEventEventArgs.cs:

		- New file.

	* FirebirdSql.Data.Firebird/FbEvent.cs:

		- Try to improve the remothe event handling, the
		new event should provide cancelation capabilities.		

2004-11-09 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep4.cs:

		- Save settings and control wheter the textbox is empty

	* FirebirdSql.WizardFramework/WizardForm.cs:

		- Save settings before raise the BeforeFinish event.

	* FirebirdSql.WizardFramework/WizardStep.cs:

		- Changed the SaveSettings method to public.

2004-11-07 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterWizardSettings.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterWizardForm.cs:

		 -Added initial DataAdapter configuration code in the BeforeFinsh event.

	* Fixed FxCop rules.

2004-11-06 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbConnectionInternal.cs:
	* FirebirdSql.Data.Firebird/FbEvent.cs:
	* FirebirdSql.Data.Common/IDatabase.cs:
	* FirebirdSql.Data.Embedded/FesDatabase.cs:
	* FirebirdSql.Data.Gds/GdsDatabase.cs:
	* FirebirdSql.Data.Gds/GdsEventManager.cs:

		- Improved Firebird Events Implementation.

	* Fixed FxCop rules.

	* Added FxCop project file to the builds directory.

2004-11-05 Carlos Guzman Alvarez  <carlosga@telefonica.net>


	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep3.cs:

		- Fixed problem with the Setting update.

	* FirebirdSql.Data.Firebird/Embedded/FesStatement.cs:
	* FirebirdSql.Data.Firebird/Embedded/XSQLDA.cs:
	* FirebirdSql.Data.Firebird/Embedded/XsqlMarshaler.cs:

		- Better handling of the XSQLVAR strings, now
		instead of being marshaled directly as strings
		they are being marshaed as byte arrays, what
		would make possible to handle strings with a
		multibyte encoding.
		The encoding/decoding of the strings are being 
		done using the connection character set.


-------------------------- Beta 1 ----------------------------


2004-11-04 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Updated Wizard Framework sources.

2004-11-01 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbDataTypes.cs:

		- Update schema information (Thanks to Viatcheslav V. Vassiliev for his feedback)

	* Updated documentation of the WizardFramework classes.

	* Removed WizardState class (the validation will be done
	using the DialogResult as the wizard will be called always
	using the ShowDialog method).

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Fixed bug on initialization of the user id

	* FirebirdSql.WizardFramework/WizardStep.cs:	

		- Added support for custom navigations (for next button)

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationWizard.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep3.cs:

		- Implemented custom navigation.

2004-10-31 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/Connection/Editor/FbConnectionStringEditor.cs:

		- Minor change for allow the editor to be used with the default constructor.


	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDataSetGenerator.cs:

		- New class for the DataSet Genetator (without implementation)

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep3.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep4.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep5.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep6.cs:

		- New steps (without implementation)

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep2.cs:

		- Implement funcionaly of the new connection button.
		It will call the FbConnectionStringEditor.

		- Changed settings handling.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterWizardSettings.cs:

		- New inner class for handle wizard settings.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationWizard.cs:

		- Change step loading and settings handling.

2004-10-30 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/StatementBase.cs:

		- Format the statement plan using the character set
		of the connection.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDesigner.cs:
		
		- Run the wizard automatically when the componenet is created (.NET 2.0 only).

		- Initialize the SelectCommand, InsertCommand, UpdateCommand and DeleteCommand
		when the component is created (the first time only) (.NET 2.0 only).

2004-10-29 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.WizardFramework/WizardSettings.cs:
	* FirebirdSql.WizardFramework/WizardSettingsManager.cs:

		- New classes.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep2.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationWizard.cs:

		- Added some settings handling code.

	* FirebirdSql.WizardFramework/WizardForm.cs:
	* FirebirdSql.WizardFramework/WizardStep.cs:	
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep2.cs;
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationWizard.cs:

		- Added better validations.

2004-10-28 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Modified the build file to include the Wizard Framework.

	* FirebirdSql.WizardFramework/WizardForm.cs:

		- Minor change.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep1.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationStep2.cs:
	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterConfigurationWizard.cs:

		- New files for the FbDataAdapter Configuration wizard (not finished)

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDesigner.cs:

		- Changes for load the Wizard. (not finished)

2004-10-25 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionStringBuilder.cs:
	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Changes for try to get the Role to be working again (Thanbks to Oleg Deribas for his feedback)

2004-10-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.WizardFramework/ActionStep.cs:
	* FirebirdSql.WizardFramework/WelcomeStep.cs:	

		- New clases.

	* FirebirdSql.WizardFramework

		- New Directory

	* FirebirdSql.WizardFramework/WizardForm.cs:
	* FirebirdSql.WizardFramework/WizardStep.cs:	
	* FirebirdSql.WizardFramework/WizardState.cs:

		- Added an initial implementation of a simple wizard Framework
		to simplify the creation of the provider Design Time Wizards.

		* It's under heavy development so it's not finished and it's untested *

 		* For now it will be not included in the build process *

2004-10-23 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Isql/FbBatchExecution.cs:

		- Minor fix (Thanks to Viatcheslav V. Vassiliev for his
		feedback)

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Fixed Input parameter describe when the Prepare method
		is called before the FbCommand instance has parameters assigned.
		( test case included ) Thanks to Viatcheslav V. Vassiliev for his
		feedback

	* FirebirdSql.Data.Firebird/Design/Command/Designer/FbCommandDesigner.cs:
		
		- Override PreFilterAttributes and add teh DesignTimeVisibleAttribute using
		the FbCommand.DesignTimeVisible property value.

	* FirebirdSql.Data.Firebird/Design/DataAdpater/Designer/FbDataAdapterDesigner.cs:

		- Minor changes (contains test code).

2004-10-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/RemoteEvent.cs:
	* FirebirdSql.Data.Common/EventParameterBuffer.cs:

		- Fixed TPB generation (Olaf Lüder)

2004-10-19 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Fixed command text initialization.

2004-10-17 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Design/Connection/Designer/FbCommandDesigner.cs

		- New class.

	* FirebirdSql.Data.Firebird/FbCommand.cs

		- Added Designer Attribute.

	* FirebirdSql.Data.Firebird/Design/DataAdapter/Designer/FbDataAdapterDesigner.cs

		- New class.

	* FirebirdSql.Data.Firebird/FbDataAdapter.cs

		- Added Designer Attribute.

2004-10-17 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Reorganization of the Design Time support classes.

2004-10-09 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/StringCollection.cs:

		- Added CopyTo method.

2004-10-05 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbSecurity.cs

		- Added better checks for user data.

2004-10-04 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommandbuilder.cs:

		- Fixed quoted identifier generation when
		the quote prefix or the quote suffix are null.

	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Fixed exception handling on Open method.

	* FirebirdSql.Data.Common/ArrayBase.cs:
	* FirebirdSql.Data.Embedded/FesArray.cs:
	* FirebirdSql.Data.Gds/GdsArray.cs:

		- Changes for try to allow work with arrays
		defined with lowerbound 0.

2004-10-01 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbEvent.cs:
	* FirebirdSql.Data.Common/RemoteEvent.cs:

		- Modified handling of actual event counts.

2004-09-30 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsDatabase.cs:
	* FirebirdSql.Data.Embedded/FesDatabase.cs:
	* FirebirdSql.Data.Common/EventParameterBuffer.cs:

		- Fixed EventParameter buffer handling.


2004-09-29 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Cleanup.

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:
	* FirebirdSql.Data.Firebird/FbConnectionStringBuilder.cs:

		- Removed IsolationLevel.Snapshot that is supported only 
		in .NET 2.0

2004-09-28 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	- Updated IDPL license URL to point to the FirebirdSQL project web site.

	- Fixed FbDataAdapter documentation example (Thanks to Roland Turcan)

2004-09-27 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbConnectionString.cs:
	* FirebirdSql.Data.Firebird/FbConnectionStringBuilder.cs:

		- Added new "Isolation Level" parameter for the connection string,
		that allows to set the default IsolationLevel for implicit transactions.

	* FirebirdSql.Data.Embedded/XSQLDA.cs:
	* FirebirdSql.Data.Embedded/XsqldaMarshaler.cs:

		- Changes on pointer address calculation.

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Improve handling of parameters when they have null values.
		Affects mainly the embedded server support (Thanks to Pierre 
		Arnaud for his feedback)	

2004-09-25 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbField.cs:

		- Fix for SetValue method on character values trimming when 
		working with system tables. Affects only the embedded server 
		support (Thanks to Sander Bosman for his feedback)

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Added new synonym for the 'Server Type' parameter.

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Fixed implicit transaction handling.

	* FirebirdSql.Data.Firebird/FbCommandBuilder.cs:

		- Set IsNullable property for parameters of generated 
		commands.

	* FirebirdSql.Data.Embedded/XsqdaMarshaler.cs:

		- Minor changes on sqlind handling.

2004-09-23 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Added support for the .NET Compact Framework 2.0 Beta 1

2004-09-21 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/XdrStream.cs:
	* FirebirdSql.Data.Gds/GdsArray.cs:	
	* FirebirdSql.Data.Gds/FesArray.cs:

		- Changes on DateTime conversions by using CurrentUICulture
		instead of the InvariantCulture.

	* FirebirdSql.Data.Gds/XdrStream.cs:

		- Minor formatting changes.

2004-09-20 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbParameter.cs:
	* FirebirdSql.Data.Firebird/FbParameterCollection.cs:

		- Format changes

	* FirebirdSql.Data.Firebird/FbException.cs:

		- Minor reorganization.

	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Added new code for handle the Max Connection Pool behavior (needs testing)

	* FirebirdSql.Data.Firebird/FbConnectionStringBuilder.cs:
	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Globalization changes.

	* FirebirdSql.Data.Common/ArrayBase.cs:
	* FirebirdSql.Data.Common/IscException.cs:
	
		- Globalization changes.

	* FirebirdSql.Data.Common/IscCodes.cs:

		- Minor reorganization.

		- Added new constants for standard buffer sizes.

	* FirebirdSql.Data.Common/StatementBase.cs:
	* FirebirdSql.Data.Gds/GdsDatabase.cs:

		- Use constants instead of hard-coded values for buffer sizes

	* FirebirdSql.Data.Gds/GdsConnection.cs:

		- Added GC.SupressFinalize calls.


-------------------------- Alpha 3 ----------------------------


2004-09-18 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Added changes to the connection cleanup.

		- Fixed connection checkout from the pol.

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Fixed packet size synonym

2004-09-17 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Added new nunit test case for the database sweep (Validation service)

	* FirebirdSql.Data.Gds/GdsServiceManager.cs:
		
		- Minor fix.

2004-09-16 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbConnectionInternal.cs:

		- Added new GetSchema methods to FbConnectionInternall class.

	* FirebirdSql.Data.Gds/GdsDatabase.cs:

		- Fixed buffer size for the Server Version
		50 bytes seems to be not enough when working 
		against Firbeird 1.0.3 (it's weird because it returns 
		a string of length less than 50)


2004-09-15 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDbConnection.cs:

		- Renamed to FbConnectionInternal.

	* FirebirdSql.Data.Firebird/FbConnectionInternal.cs:

		- New file (ADO.NET 2.0 has an DbConnectionInternal that should be implemented
		in ado.net provider implementations this class should be used in the future
		as base for that class implementation)

	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbTransaction.cs:
	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:
	* FirebirdSql.Data.Firebird/FbDataAdapter.cs:
	* FirebirdSql.Data.Firebird/FbDatabaseInfo.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDbSchema.cs:
	* FirebirdSql.Data.Firebird/FbEvent.cs:
	* FirebirdSql.Data.Firebird/FbException.cs:

		- Formatting changes.

		- Moved some of the FbConnection and FbTransaction classes
		funcionality to FbConnectionInternal.

		With the new changes the connection handling matches better the
		.net 2.0 compliant version i have in my local tree and will allow
		an easy transaction in the future to ADO.NET 2.0.

2004-09-13 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Added changes on connection pool handling.

	* FirebirdSql.Data.Firebird/FbConnectionPool.cS:

		- Minor improvements on pool handling.

		- Fixed bug on GetConnection method when
		timestamps are equal including the milliseconds
		(Thanks to Alessandro Petrelli for his help ontesting the problem)

2004-09-12 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Added better lock handling in the FbPoolManager class.
		
2004-09-11 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Return back to use regular expressions for
		connection string parsing as they ar emore precise
		for this purpouse (Thanks to Sven Kammradt for his feedback)

2004-09-10 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- CheckState shouldn't check for eof.

	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Added changes for the initial implementation
		iof a Wendell Wilkie suggestion for improve 
		connection checkouts adn pools load.

2004-09-09 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Added new ConnectionPoolsCount and 
		GetPooledConnectionCount members to the
		FbConnection class.

		- Minor change in FbConnectionPool class.


2004-09-08 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Updated documentation.

	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Minor fix for better detection of the datareader position.


2004-09-03 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Fixed pool cleaning when the for pools with
		connection lifetime of 0.

	* Formatting changes.

	* Added new parameter buffer classes and reworked existent 
	parameter buffer classes.

	New classes:

		- TransactionParameterBuffer.cs

		- BlobParameterBuffer.cs

	* Renamed parameter buffer classes:

		- BufferBase -> ParameterBuffer
		- DpbBuffer -> DatabaseParameterBuffer
		- SpbBuffer -> ServiceParameterBuffer
		- EpbBuffer -> EventParameterBuffer

	* FirebirdSql.Data.Common/IDatabase.cs:
	* FirebirdSql.Data.Common/IServiceManager.cs:
	* FirebirdSql.Data.Common/RemoteEvent.cs:
	* FirebirdSql.Data.Embedded/FesDatabase.cs:
	* FirebirdSql.Data.Embedded/FesServerManager.cs:
	* FirebirdSql.Data.Embedded/FesTransaction.cs:
	* FirebirdSql.Data.Gds/GdsDatabase.cs:
	* FirebirdSql.Data.Gds/GdsBlob.cs:
	* FirebirdSql.Data.Gds/GdsTransaction.cs:
	* FirebirdSql.Data.Gds/GdsServerManager.cs:
	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbDbConnection.cs:
	* FirebirdSql.Data.Firebird/FbTransaction.cs:
	* FirebirdSql.Data.Firebird/Services/FbService.cs:
	* FirebirdSql.Data.Firebird/Services/FbBackup.cs:
	* FirebirdSql.Data.Firebird/Services/FbRestore.cs:
	* FirebirdSql.Data.Firebird/Services/FbConfiguration.cs:
	* FirebirdSql.Data.Firebird/Services/FbLog.cs:
	* FirebirdSql.Data.Firebird/Services/FbSecurity.cs:
	* FirebirdSql.Data.Firebird/Services/FbStatistical.cs:
	* FirebirdSql.Data.Firebird/Services/FbServerProperties.cs:
	* FirebirdSql.Data.Firebird/Services/FbValidation.cs:
		
		- Improved parameter buffer handling

2004-09-02 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/IscCodes.cs:

		- Added Firebird facilities codes.

		- Added ISC_MASK code for isc error code generation.

	* FirebirdSql.Data.Common/IscException.cs:

		- Changes on the error collection handling

		- Added new statioc method for generation of isc error codes.

	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Added changes for try to get the connection pooling working correctly.
		(Thanks to Alessandro Petrelli.  for his feedback)

2004-08-31 Carlos Guzman Alvarez  <carlosga@telefonica.net>
	
	* FirebirdSql.Data.Firebird/Embedded/FbClient.dll:

		- Allow the embedded GDS to be built for work against Vulcan.

2004-08-30 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Added changes to the GetSchemaTable method to 
		avoid schema command execution when the field
		doesn't belong to a firebird table.
		(Thanks to Gregory P. for his feedback)

2004-08-26 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Fixed bug #1017108

2004-08-25 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/IscException.cs:

		- Improved building of the exception message.

	* FirebirdSql.Data.Embedded/FesServiceManager.cs:

		- Monor fix.

	* FirebirdSql.Data.Firebird/Services/FbService.cs:

		- Do not throw an exception if the service is closed and
		a new call to close is done.

	* FirebirdSql.Data.Common/IDatabase.cs:
	* FirebirdSql.Data.Common/FesDatabase.cs:
	* FirebirdSql.Data.Common/GdsDatabase.cs:
	* FirebirdSql.Data.Firebird/FbDbConnection.cs:

		- Changes on GetDatabaseInfo overloads.

		- Make the GetServerVersion method to request only 50 bytes.

	* FirebirdSql.Data.Common/StatementBase.cs:
		
		- Try to get the statement plan only 4 times,
		if the plan cannot be retrieved returns null (Thanks to Claudio Valderrama)

	* FirebirdSql.Data.Firebird/FbConnectionStringBuilder.cs:
	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Minor changes and improvements over the latest commit.

2004-08-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbColumns.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDomains.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParameters.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbViewColumnsUsage.cs:

		- Set the CHARACTER_OCTET_LENGTH to 0 if the comlumns is not a char/varchar column.

	* FirebirdSql.Data.Common/StatementBase.cs:

		- Fixed bug #1015453.

	* FirebirdSql.Data.Firebird/FbConnectionStringBuilder.cs:
	* FirebirdSql.Data.Firebird/FbConnectionString.cs:
	* FirebirdSql.Data.Firebird/FbConnection.cs:
	
		- Changed FbConnectionString class to be internal.

		- NEw class to build connection strings.

	* FirebirdSql.Data.Firebird/Design/*.cs:
	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Include the classes only if we are doing the build using MS.NET
	
	* FirebirdSql.Data.Common/DbField.cs:

		- Trim trainling spaces for char fields when using the
		embedded server and character sets with 2/3 characters per byte.


2004-08-23 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Embedded/FbClient.cs:

		- Cleanup.

		- Change isc_dsql_prepare to get a byte array as parameter instead of a string.

	* FirebirdSql.Data.Embedded/FesStatement.cs:

		- Send a byte array in the isc_dsql_prepare call instead of a string.


-------------------------- Alpha 2 ----------------------------


2004-08-22 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbColumns.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDomains.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParameters.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbViewColumnsUsage.cs:

		- Added new CHARACTER_OCTET_LENGTH column

		- Fixed size for char/varchar columns

2004-08-21 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* The nunit test suite will run now using UNICODE_FSS 
	by default.


	* FirebirdSql.Data.Firebird/DbSchema/FbColumns.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDomains.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParameters.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbViewColumnsUsage.cs:

		- Fixed NUMERIC_PRECISION value.
	
	* FirebirdSql.Data.Firebird/FbCommandBuilder.cs:

		- Do not set the numeric precision and scale if the parameter
		is not a decimal or numeric type.

	* FirebirdSql.Data.Firebird/DbSchema/FbMetaDataCollections.cs:

		- Added Restrictions definition.

	* FirebirdSql.Data.Firebird/DbSchema/FbMetaDataCollections.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDataTypes.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbRestrictions.cs:

		- Added name to the DataTable.

2004-08-20 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Fixed bug #1013031

2004-08-19 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbColumns.cs:

		- Added domain information.

2004-08-18 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Updated nant build system.

		- Put in different directories the nant build files
		of the ADO.NET Provider and the Borland Data Provider.

	* The build will done always in a single assembly.

	* Fixed Globalization problems reported by FxCop.

2004-08-16 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/StatementBase.cs:

		- [TESTING CHANGE] Do not request the owner when
		describing statements as we are not using it for 
		never at this moment.

	* FirebirdSql.Data.Gds/GdsConnection.cs:

		- Added a call to GC.SuprresFinalize in the constructor.


2004-08-15 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDataAdapter.cs:

		- Throw a InvalidOperationException instead of a
		DataAdapterException that it's .NET 2.0 specific.

		- Minor change on update count, seems that it needs to return
		the number of *DataRows* updated.

	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Cleanup.

2004-08-14 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Minor change on Null value check.

		- Removed Attributes form the CommandTimeout,
		they prevents the sources to be built using .net 1.0
		(Thanks to Mara)

	* FirebirdSql.Data.Firebird/FbDataAdapter.cs:

		- Override the DbDataAdapter.Update(DataRow[] dataRows, DataTableMapping tableMapping)
		method to make calls to FbCommand.ExecuteNonQuery method always on
		inserts, updates and deletes.

		It's  on *testing* for now and it's not clear if it will be finally used.

2004-08-13 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Set conenction string default value to an empty string.

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Changes on constructor implementation.


2004-08-12 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/TypeHelper.cs:

		- Fixed Float to mapping (Thanks to HDV).

	* FirebirdSql.Data.Firebird/DbSchema/FbForeignKeys.cs:

		- Added IS_DEFERRANLE and INITIALLY_DEFERRED columns


2004-08-11 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Do not use GetMaxByteCount to calc the number of bytes for the input parameters.

	* FirebirdSql.Data.Firebird/DbSchema/FbColumns.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDomains.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParameters.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbViewColumnUsage.cs:

		- Improved numeric precision handling.

	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Fixed bug #1007104

	* FirebirdSql.Data.Firebird/DbSchema/FbColumns.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDomains.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParameters.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbViewColumnUsage.cs:

		- Improved numeric precision handling.

		- Minor fix to schema queries to let them to run
		using the embedded server.

2004-08-10 Carlos Guzman Alvarez  <carlosga@telefonica.net>	

	* FirebirdSql.Data.Common/StatementBase.cs:
	* FirebirdSql.Data.Embedded/FesStatement.cs:
	* FirebirdSql.Data.Gds/GdsStatement.cs:
	* FirebirdSql.Data.Firebird/FbCommand.cs:
		
		- Cleanup.

 		- Reworked handling of stored procedure output 
		parameter values.

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Improved input parameter descriptor generation.

	* Last changes for the database schmeas support:


		* All source files has been renamed to remove
		the Schema suffix (FbTablesSchema.cs -> FbTables.cs)
		The same for the class names.

		* There are a new 'Restrictions' schema that will
		return the restriction columns for each schema.

		* There are new columns in some schemas:

			   XXXX_CATALOG
			   XXXX_SCHEMA

		That will make the returned schemas more
		general and compatible with other databases
		(what will be nice for .net 2.0 as the schema
		support is in the System.Data.Common.DbConnection
		class)

		These new columns are restriction columns as
		well (the value will be null always) 		


2004-08-07 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Removed test comments.

		- Throw an exception when trying to set the FetchSzie with an
		active DataReader open.

		- Set fetch size on execute instead of fetch.

	* FirebirdSql.Data.Firebird/DbSchema/FbTablesSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbMetaDataCollections.cs:

		- Now it's no possible to filter by the IS_SYSTEM_TABLE column,
		doing that using the table type restriction.

	* FirebirdSql.Data.Common/StatementBase.cs:
	* FirebirdSql.Data.Embedded/FesStatement.cs:

		- Removed Rows property.

	* FirebirdSql.Data.Gds/GdsStatement.cs:

		- Removed Rows property.

		- Use a Queue instead of a object[] to store the rows.
		Performance looks similar (seems to be better with greater
		fetch sizes) and the code is more readable.

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Changes on the way that output parameters
		for Stored procedures query are retrieved.

	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Minor changes in method calls.

2004-08-06 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Fixed invalid references in the documentation reported by 
	.NET 2.0

	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Cleanup.

	* FirebirdSql.Data.Firebird/DbSchema/FbTablesSchema.cs:

		- The system tables will now be filtered using the table type parameter.

	* FirebirdSql.Data.Firebird/FbConnection.cs:
		
		- Check connection state in GetSchema methods.	

2004-08-05 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/StatementBase.cs:
	* FirebirdSql.Data.Embedded/FesStatement.cs:
	* FirebirdSql.Data.GDS/GdsStatement.cs:
	* FirebirdSql.Data.Firebird/FbConnectionString.cs:
	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Fetch Size implementation that allows to define the 
		fetch size (number of rows fetches in the call selectable queries)
		in the connection string and command objects.

	* FirebirdSql.Data.Firebird/FbConnectionString.cs:

		- Fixed bug #1004055 

		- Added new nunit test.

	* FirebirdSql.Data.Firebird/DbSchema/FbDbSchema.cs:

		- Added a little hack for the Tables schema restrictions.
	

2004-08-04 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbColumnsSchema.cs:

		- Removed PRIMARY_KEY and UNIQUE_KEY columns

	* FirebirdSql.Data.Firebird/DbSchema/FbPrimaryKeysSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbUniqueKeysSchema.cs:

		- Allow filter by the column name


2004-08-03 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbColumnsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbViewColumnUsage.cs:

		- Added new IS_ARRAY column.

	* FirebirdSql.Data.Firebird/DbSchema/FbForeignKeySchema.cs:

		- Fixed error in latest commit.

2004-08-02 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbForeignKeySchema.cs:

		- Updated sql statement.

	* FirebirdSql.Data.Common/StatementBase.cs:
	* FirebirdSql.Data.Gds/GdsStatement.cs:
	* FirebirdSql.Data.Embbeded/FesStatement.cs:

		- Some cleanup and refactoring.

2004-08-01 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDbSchemaType.cs:

		- Removed not implemented elements.

		- Added new MEtaDataCollections element.
	
	* FirebirdSql.Data.Firebird/FbMetaDataCollections.cs:

		- Added restriction counts values.

		- Modided the constructos of the schame classes
		to remove the restriction count value.

	* FirebirdSql.Data.Firebird/FbDbSchema.cs:

		- Use the new MetaDataCollections schema to check the
		restriction count.

2004-07-31 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbDataReader.cs:
	* FirebirdSql.Data.Firebird/FbTransaction.cs:

		- Removed the code of the partial batch command
		execution (that was available only using FbDataReader.NextResult)


	* FirebirdSql.Data.Gds/GdsStatement.cs:

		- Added testing change on statement execution.
		Now on execute we will request the number of rows 
		affected in the same message.

	* FirebirdSql.Data.Firebird/DbSchema/*.cs:

		- Updated Database schema support.

	* FirebirdSql.Data.Firebird/DbSchema/FbMetaDataCollections.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDataTypes.cs:

		- Added new files.

	* FirebirdSql.Data.Firebird/DbSchema/FbProviderTypesSchema.cs:

		- Removed file.


	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Added new CreateDatabase overload

	* FirebirdSql.Data.Firebird/FbCommandBuilder.cs:

		- Updated DeriveParameters method to work with the new
		Database schema stuff.


2004-07-30 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Added new GetSchema method

		- Set GetDbSchemaTable method as Obsolete.

	* FirebirdSql.Data.Firebird/FbDbSchemaType.cs:

		- Removed _ from the element names.

		- Set as obsolete.

	* Improvements on Database schema support.

	* FirebirdSql.Data.Firebird/FbService.cs:

		- Fixed parsing database infor buffer (Thanks to Christian for his feedback).


2004-07-29 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDbSchema.cs:

		- Fixed bug #1000160

2004-07-28 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDataReader.cs:
	* FirebirdSql.Data.Common/FbCharsetCollection.cs:
	* FirebirdSql.Data.Common/FbIscErrorCollection.cs:
	* FirebirdSql.Data.Common/DbValue.cs:
	* FirebirdSql.Data.Common/BlobBase.cs:
	* FirebirdSql.Data.Common/TypeEncoder.cs:
	* FirebirdSql.Data.Common/StatementBase.cs:

		- Fixed FxCop rules.

2004-07-27 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbTransaction.cs:
	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Removed limitation of one active 
		data reader per connection, now it
		will be one active data reader per
		command.

		NUNit tests will be commited later 
		today.


2004-07-26 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbParameter.cs:

		- Fixed bug #998002


-------------------------- Alpha 1 ----------------------------

2004-07-21 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbParameter.cs:

		- Fixed bug #995178

2004-07-20 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Updated documentation.

	* Updated assembly version.

	* Updated installation script.
	With th enew changes the assembly will be registered
	in the HKLM\Software\Microsoft\.NETFramework\AssemblyFolders
	registry element, this will allow the assembly to be shown by the
	Visual Studio Add Reference dialog.


2004-07-18 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	- Private methods naming changes in all classes, using PascalCase,
	to match MS Guidelines.

2004-07-17 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Changed CommandTimeout property accesible only using
		explicit interfaces.

	* FirebirdSql.Data.Firebird/DbSchema/FbDomainsSchema.cs:

		- Fixed IS_NULLABLE column value.


2004-07-16 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbColumnsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDomainsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParametersSchema.cs:

		- Fixed mistake in latest commit.

	* FirebirdSql.Data.Firebird/FbCommandBuilder.cs:

		- Make use of the new PARAMETER_DIRECTION column.

		- Remove COLUMN_SIZE reference.

2004-07-15 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbColumnsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbDomainsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParametersSchema.cs:

		- Report correct size for blob columns.

2004-07-12 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbFunctionsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbIndexeschema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbGeneratorsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbTablesSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbTriggersSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbUniqueKeysSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbViewColumnsUsageSchema.cs:


		- Columns that indicates wheter an object is a system
		object are now called IS_SYSTEM_XXXX.

		- Columns that indicates wheter an object is inactive
		are now called IS_INACTIVE. 
		

	* FirebirdSql.Data.Firebird/DbSchema/FbColumnsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbForeignKeysSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbIndexesSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbPremaryKeysSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParametersSchema.cs:

		- Set ORDINAL_POSITION as name for all ordinal columns.

2004-07-11 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCharset.cs:

		- Added Serializable attribute.

2004-07-10 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/DbSchema/FbDomainsSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParametersSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbProceduresSchema.cs:

		- Added AcceptChanges call.

	* FirebirdSql.Data.Firebird/FbDataReader.cs:

		- Cleanup.

	* FirebirdSql.Data.Firebird/DbSchema/FbProceduresSchema.cs:

		- Return intputs and outputs columns null values
		as 0.

	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParametersSchema.cs:

		- Renamed PARAMETER_TYPE column as PARAMETER_DIRECTION
		and set the value as ParameterDirection.Input or
		ParameterDirection.Output.

2004-07-02 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Set actual CreateDatabase and DropDatabase as Obsolete

		- Added new CreateDatabase and DropDatabase methods
		that uses connection strings.


2004-07-01 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/DbField.cs:

		- Added new IsDecimal method.

	* FirebirdSql.Data.Common/FbDataReader.cs:

		- Set numeric precision and scale only for decimal/numeric datatypes.


2004-06-30 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbDbSchemaType.cs:

		- Added Serializable attribute.

	* FirebirdSql.Data.Firebird/FbTransaction.cs:
	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Simplify constructor implementation.

	* FirebirdSql.Data.Firebird/FbParameter.cs:

		- Added private keyyworkd to class fields.

	* FirebirdSql.Data.Firebird/FbConnection.cs:

		- Simplified BeginTransaction overloads.

2004-06-25 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsDatabase.cs:

		- Fixed bug on Detach method.	

	* FirebirdSql.Data.common/IDatabase.cs
	* FirebirdSql.Data.common/ITransaction.cs
	* FirebirdSql.Data.common/StatementBase.cs
	* FirebirdSql.Data.Embedded/FesDatabase.cs:
	* FirebirdSql.Data.Embedded/FesTransaction.cs:
	* FirebirdSql.Data.Embedded/FesStatement.cs:
	* FirebirdSql.Data.Gds/GdsDatabase.cs:
	* FirebirdSql.Data.Gds/GdsTransaction.cs:
	* FirebirdSql.Data.Gds/GdsStatement.cs:
	* FirebirdSql.Data.Firebird/FbConnection.cs:
	* FirebirdSql.Data.Firebird/FbCommand.cs:
	* FirebirdSql.Data.Firebird/FbTransaction.cs:
	* FirebirdSql.Data.Firebird/FbDbConnection.cs:	

		- Implement IDisposable interface in 
		Database, Transaction and statement implementations
		of GDs's.

		Prior sources are tagged as NP_1_7_Alpha1.

		* This change needs carefully review/testing. *

	* FirebirdSql.Data.Firebird/DbSchema/FbProcedureParametersSchema.cs:
	* FirebirdSql.Data.Firebird/DbSchema/FbColumnsSchema.cs:

		- Fixed NUMERIC_SCALE column value (Thanks to Jack for his feedback).

2004-06-24 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Services/FbService.cs:

		- Modify the delegate and event used for
		handling service output by adding a new
		ServiceOutputEventArgs class (Thanks to Mike Scott for his feedback).

2004-06-23 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/Services/*.cs:
	
		- Changes on output processing, now it's going to be done
		using an event instead of the GetNextLine method.
		
		Start methods has been renamed to Execute in every class.
		
		(Thanks to Pierre Y. for his suggestion)

2004-06-16 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsArray.cs:

		- Fix Array implementation. All NUnit tests suite are running fine.

	* Added setup projects.

	* FirebirdSql.Data.Firebird.UnitTest/FbDataAdapter.cs:

		- Added new nunit test for check dataset fill using
		an execute procedure statement.

2004-06-14 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbConenctionString.cs:

		- Added Validate method.

	* Updated/added documentation of classes:

		- FbConnection
		- FbEvent
		- FbService

	* Added BDP NUnit test suite.


2004-06-13 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Bdp/Fbconnection.cs:

		- Finish connection code for work with new
		GDS implementation structure.


2004-06-12 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Gds/GdsStatement.cs:

		- Fixed bug in Fetch method when working
		with statements using EXECUTE PROCEDURE syntax.


2004-06-08 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* Finished first stage of the events reimplementation.


2004-06-02 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Firebird/FbCommand.cs:

		- Simplify handling of input parameters with null values (Thanks to Jojakim Stahl).

	* FirebirdSql.Data.Firebird/DbSchema/FbForeignKeysSchema.cs:

		- Fix order by clausule.

	* FirebirdSql.Data.Firebird/FbConnectionPool.cs:

		- Run cleanup over pooled connections
		only when there are a number of pooled connections
		greater than the min pool size (needs testing).

2004-06-01 Carlos Guzman Alvarez  <carlosga@telefonica.net>

	* FirebirdSql.Data.Common/FbCommandBuilder.cs:
	
		- Improved DeriveParameters implementation.

	* FirebirdSql.Data.Common/Descriptor.cs:

		- Changed ToBlr method for use a MemoryStream.

	* FirebirdSql.Data.Common/IscError.cs:
	* FirebirdSql.Data.Common/IscCodes.cs:
	* FirebirdSql.Data.Common/IscException.cs:

		- Clean up on fatal errors exceptions.

	* FirebirdSql.Data.Common/IscException.cs:

		- Rewrite the way the exeption emessage is built.
		
	* FirebirdSql.Data.Common/IscExceptionHelper.cs:

		- Removed.

	* FirebirdSql.Data.Common:

		- RowDescriptor.cs renamed as Descriptor.cs


2004-05-28 Carlos Guzman Alvarez  <carlosga@telefonica.net>

    * FirebirdSql.Data.Common:

    Removed classes:

        - AttachmentParams
        - Factorybase
        - IAttachment

    Renamed classes:

        - IDbAttachment    -> IDatabase
        - ISvcAttachment   -> IServiceManager

    * FirebirdSql.Data.Embedded:

    Removed classes:

        - FesFactory
        - FesAttachment

    Renamed classes

        - FesDbAttachment     -> FesDatabase
        - FesSvcAttachment    -> FesServiceManager
        * FirebirdSql.Data.Gds: 
    Removed classes:

        - GdsFactory

    Renamed classes

        - GdsAttachment       -> GdsConnection
        - GdsDbAttachment     -> GdsDatabase
        - GdsSvcAttachment    -> GdsServiceManager

    * FirebirdSql.Data.Firebird:

    New classes:

        - FbConnectionString

    * FirebirdSql.Data.Firebird.Service:

    Removed classes:

        - FbServiceParameters.

    (The services implementation now works with a connection strings. 